/*
 * File name: Complex.java
 * Date:      2014/11/03 16:03
 * Author:    Jan Faigl
 */

public class Complex {

    //data fields
    private double re = 0.;
    private double im = 0.;

    //constructors
    public Complex() {
    }

    public Complex(double r) {
        re = r;
    }

    public Complex(double r, double i) {
        this(r);
        im = i;
    }

    //methods (operations)
    public double getAbs() {
        return Math.sqrt(re * re + im * im);
    }

    public Complex plus(Complex b) {
        double r = re + b.re;
        double i = im + b.im;
        return new Complex(r, i);
    }

    public Complex minus(Complex b) {
        Complex a = this;
        return new Complex(a.re - b.re, a.im - b.im);
    }

    public Complex times(Complex b) {
        Complex a = this;
        double r = a.re * b.re - a.im * b.im;
        double i = a.re * b.im + a.im * b.re;
        return new Complex(r, i);
    }

    public static Complex plus(Complex a, Complex b) {
        double r = a.re + b.re;
        double i = a.im + b.im;
        Complex sum = new Complex(r, i);
        return sum;
    }

    @Override
    public String toString() {
        if (im == 0) {
            return re + "";
        } else if (re == 0) {
            return im + "i";
        } else if (im < 0) {
            return re + " - " + (-im) + "i";
        }
        return re + " + " + im + "i";
    }
}
