/*
 * File name: DemoMatrix.java
 * Date:      2014/11/04 13:38
 * Author:    Jan Faigl
 */

public class DemoMatrix {

    public static void main(String[] args) {
        Matrix m1 = new Matrix(3, 3);
        Matrix m2 = new Matrix(3, 3);

        m1.fillRandom();
        m2.fillRandom();
        Matrix sum = m1.sum(m2);

        System.out.println("m1:\n" + m1);
        System.out.println("m2:\n" + m2);
        System.out.println("sum:\n" + sum);

        Matrix prod = m1.product(m2);
        System.out.println("prod:\n" + prod);

        prod = m1.productTrans(m2);
        System.out.println("prodTrans:\n" + prod);

        final int N = 1000;
        m1 = new Matrix(N, N);
        m2 = new Matrix(N, N);
        m1.fillRandom();
        m2.fillRandom();

        long t1 = System.currentTimeMillis();
        m1.product(m2);
        long t2 = System.currentTimeMillis();
        System.out.printf("Time %14s: %6d ms%n", "product", (t2 - t1));
        m1.productTrans(m2);
        long t3 = System.currentTimeMillis();
        System.out.printf("Time %14s: %6d ms%n", "productTrans", (t3 - t2));
    }

}
